//
// gpio.ino
//

#include <fastio.h>

fastIoPin<5> OutputPin; // Gives the name, "OutputPin" to the I/O pin 5. Accessing an I/O pin by name is readabler than accessing it by number.
fastIoPin<6> InputPin;  // Gives the name, "InputPin" to the I/O pin 6.

void setup()
{
  pinMode(3,OUTPUT);
  pinMode(4,INPUT_PULLUP);

  OutputPin.pinMode(OUTPUT); // sets OutputPin OUTPUT mode.
  InputPin.pinMode(INPUT_PULLUP); // sets InputPin INPUT_PULLUP mode.
} // setup

void loop()
{
  int data; // Data read from a I/O pin

  digitalWrite(3, LOW); // Standard expression.
  digitalWrite<3>(LOW); // Same meaning as previous line. But it runs faster. It is allowed to use both standard expression and this expression in the same file. 

  data=digitalRead(4);   // Standard expression
  data=digitalRead<4>(); // Same meaning as previous line. But it runs faster.

  OutputPin.digitalWrite(HIGH); // writse HIGH to OutputPin.
  OutputPin=HIGH;               // Abbreviated expression for the previous line.

  data=InputPin.digitalRead(); // reads data from InputPin.
  data=InputPin;               // Abbreviated expression for the previous line.
} // loop
