//
// time-comparison.ino
//

#include<fastio.h>

fastIoPin<13> LEDpin; // Gives the name, "LEDpin" to pin 13.

void setup()
{
  Serial.begin(9600); // Opens serial port at 9600bps.
} // setup

void loop()
{
  uint32_t start,stop; // variables for time I/O access
  uint8_t data; // data read form a pin

  pinMode(13,OUTPUT); // sets pin 13 OUTPUT.
  
  // Standard write
  Serial.print("Standard write:");
  start=millis();
  for(int i=0; i<10000; i++) {
    digitalWrite(13,LOW);
    digitalWrite(13,HIGH);
    digitalWrite(13,LOW);
    digitalWrite(13,HIGH);
    digitalWrite(13,LOW);
    digitalWrite(13,HIGH);
    digitalWrite(13,LOW);
    digitalWrite(13,HIGH);
    digitalWrite(13,LOW);
    digitalWrite(13,HIGH);
  } // for i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");
  
  // Register accssess write
  Serial.print("Register access write:");
  start=millis();
  for(int i=0; i<10000; i++) {
    PORTB&=~_BV(5);
    PORTB|=_BV(5);
    PORTB&=~_BV(5);
    PORTB|=_BV(5);
    PORTB&=~_BV(5);
    PORTB|=_BV(5);
    PORTB&=~_BV(5);
    PORTB|=_BV(5);
    PORTB&=~_BV(5);
    PORTB|=_BV(5);
  } // for i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");
  
  // digitalWrite<>() write
  Serial.print("digitalWrite<>() write:");
  start=millis();
  for(int i=0; i<10000; i++) {
    digitalWrite<13>(LOW);
    digitalWrite<13>(HIGH);
    digitalWrite<13>(LOW);
    digitalWrite<13>(HIGH);
    digitalWrite<13>(LOW);
    digitalWrite<13>(HIGH);
    digitalWrite<13>(LOW);
    digitalWrite<13>(HIGH);
    digitalWrite<13>(LOW);
    digitalWrite<13>(HIGH);    
  } // int i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");

  // Write access to a pin by name with digitalWrite
  Serial.print("Write access to a pin by name with digitalWrite:");
  start=millis();
  for(int i=0; i<10000; i++) {
    LEDpin.digitalWrite(LOW);
    LEDpin.digitalWrite(HIGH);
    LEDpin.digitalWrite(LOW);
    LEDpin.digitalWrite(HIGH);
    LEDpin.digitalWrite(LOW);
    LEDpin.digitalWrite(HIGH);
    LEDpin.digitalWrite(LOW);
    LEDpin.digitalWrite(HIGH);
    LEDpin.digitalWrite(LOW);
    LEDpin.digitalWrite(HIGH);    
  } // int i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");
  
  // Write access to a pin by name with = operator
  Serial.print("Write access to a pin by name with = operator:");
  start=millis();
  for(int i=0; i<10000; i++) {
    LEDpin=LOW;
    LEDpin=HIGH;
    LEDpin=LOW;
    LEDpin=HIGH;
    LEDpin=LOW;
    LEDpin=HIGH;
    LEDpin=LOW;
    LEDpin=HIGH;
    LEDpin=LOW;
    LEDpin=HIGH;    
  } // int i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");

  Serial.println();
  pinMode(13,INPUT_PULLUP); // sets pin 13 INPUTPULLUP

  // Standard read
  Serial.print("Standard read:");
  start=millis();
  for(int i=0; i<10000; i++) {
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
    data=digitalRead(13);
  } // for i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");

  // Register accssess read
  Serial.print("Register access read:");
  start=millis();
  for(int i=0; i<10000; i++) {
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
    data=(PINB & _BV(5))!=0;
  } // for i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");
  
  // digitalRead<>() read
  Serial.print("digitalRead<>() read:");
  start=millis();
  for(int i=0; i<10000; i++) {
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
    data=digitalRead<13>();
  } // int i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");

  // Read access to a pin by name with digitalRead
  Serial.print("Read access to a pin by name with digitalRead:");
  start=millis();
  for(int i=0; i<10000; i++) {
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
    data=LEDpin.digitalRead();
  } // int i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");
  
  // Read access to a pin by name with = operator
  Serial.print("Read access to a pin by name with = operator:");
  start=millis();
  for(int i=0; i<10000; i++) {
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
    data=LEDpin;
  } // int i
  stop=millis();
  Serial.print(stop-start);
  Serial.println("ms");
  
  Serial.println();
  delay(10000);
} // loop
